%define compilers gcc g++ cc c++ g++-libstdc++-so_7
%define pkgs gcc, gcc-c++, compat-gcc, compat-gcc-c++, libstdc++so7-devel

%define abs2rel() perl -MFile::Spec -e 'print File::Spec->abs2rel(@ARGV)' %1 %2
%{expand: %%define relccache %(%abs2rel %{_bindir}/ccache %{_libdir}/ccache)}

Distribution:	CCux
Packager:  	Karsten Brockmann <arcam@ccux-linux.de>

Summary:        compiler cache
Name:      	ccache
Version:   	3.1.4
Release:   	1
License: 	GNU/GPL
URL:		http://ccache.samba.org/
Group:     	Development/Tools
Source0:        http://samba.org/ftp/ccache/%{name}-%{version}.tar.xz
Source1:        %{name}.sh.in
Source2:        %{name}.csh.in
BuildRoot: 	%{_tmppath}/%{name}-buildroot
BuildArch:	i686

BuildRequires:  perl(File::Spec)
Requires(triggerin): coreutils
Requires(triggerpostun): coreutils

%description
ccache is a compiler cache.  It acts as a caching pre-processor to
C/C++ compilers, using the -E compiler switch and a hash to detect
when a compilation can be satisfied from cache.  This often results in
a 5 to 10 times speedup in common compilations.


%prep
%setup -q -n %{name}-%{version}

sed -e 's|@LIBDIR@|%{_libdir}|g' -e 's|@CACHEDIR@|%{_var}/cache/ccache|g' \
    %{SOURCE1} > %{name}.sh
sed -e 's|@LIBDIR@|%{_libdir}|g' -e 's|@CACHEDIR@|%{_var}/cache/ccache|g' \
    %{SOURCE2} > %{name}.csh


%build
%configure
make %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT %{name}-%{version}.compilers
make install DESTDIR=$RPM_BUILD_ROOT
install -dm 755 $RPM_BUILD_ROOT%{_sysconfdir}/profile.d
install -pm 755 %{name}.sh %{name}.csh $RPM_BUILD_ROOT%{_sysconfdir}/profile.d
install -dm 755 $RPM_BUILD_ROOT%{_libdir}/ccache
for name in %{compilers} ; do
  for c in $name %{_target_cpu}-%{_vendor}-%{_target_os}-$name ; do
    ln -s %{relccache} $RPM_BUILD_ROOT%{_libdir}/ccache/$c
    echo "%ghost %{_libdir}/ccache/$c" >> %{name}-%{version}.compilers
  done
done
install -dm 770 $RPM_BUILD_ROOT%{_var}/cache/ccache


%clean
rm -fr $RPM_BUILD_ROOT


%pre
groupadd -g 120 ccache || :


%triggerin -- %{pkgs}
for name in %{compilers} ; do
  for c in $name %{_target_cpu}-%{_vendor}-%{_target_os}-$name ; do
    [ ! -x %{_bindir}/$c ] || ln -sf %{relccache} %{_libdir}/ccache/$c
  done
done
:

%triggerpostun -- %{pkgs}
for name in %{compilers} ; do
  for c in $name %{_target_cpu}-%{_vendor}-%{_target_os}-$name ; do
    [ -x %{_bindir}/$c ] || rm -f %{_libdir}/ccache/$c
  done
done
:


%files -f %{name}-%{version}.compilers
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/profile.d/%{name}.*sh
%{_bindir}/ccache
%dir %{_libdir}/ccache/
%attr(2770,root,ccache) %dir %{_var}/cache/ccache/
%{_mandir}/man1/ccache.1*

%changelog
* Tue Jan 11 2011 Karsten Brockmann <arcam@ccux-linux.de> 3.1.4-1
- Version update
* Mon Nov 29 2010 Karsten Brockmann <arcam@ccux-linux.de> 3.1.3-1
- Version update
* Tue Nov 09 2010 Karsten Brockmann <arcam@ccux-linux.de> 3.1.1-1
- Version update
* Tue Sep 21 2010 Karsten Brockmann <arcam@ccux-linux.de> 3.1-1
- version update
* Fri Jul 16 2010 Karsten Brockmann <arcam@ccux-linux.de> 3.0.1-1
- version update
* Mon Jun 21 2010 Karsten Brockmann <arcam@ccux-linux.de> 3.0-3
- regular release
* Mon May 24 2010 Karsten Brockmann <arcam@ccux-linux.de> 3.0-2
- pre1
* Thu Mar 11 2010 Karsten Brockmann <arcam@ccux-linux.de> 3.0-1
- version update
- pre0
* Fri Mar 14 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.4-4
- corrected executable flag on profile.d files
* Mon Jan 28 2008 Christian Metzen <metzench@ccux-linux.de> 2.4-3
- rebuild against gcc 4.1.2
- moved config to global cache dir / group
* Fri Apr 14 2006 Karsten Brockmann <arcam@ccux-linux.de> 2.4-2
- rebuilt spec file
